/**
 * Created by perkin on 2017/1/17.
 */
import React , { Component, PropTypes } from 'react'
import {host} from '../../routes/config/param'
import AvatarEditor from 'react-avatar-editor'
import Cropper from 'react-cropper';
import 'cropperjs/dist/cropper.css';
import './UploaderWithEdit.scss';
import request from 'superagent';
import Message from '../Message/Message'

export class UploaderWithEdit extends Component{
    constructor(props){
        super(props)
        this.state = {
            isUploadPoster:true,
            uploadPicSucc:false,
            imgView:'',  //本地上传所有预览相关
            posterData:'', //上传成功返回的图片url
            savedPoster:'',
            cropInfo:{}
        }
    }
    componentDidMount(){
    }
    componentWillReceiveProps(nextProps){
        if(nextProps.imgView){
            this.setState({
                imgView: nextProps.imgView
            })
        }
    }
    handleUploadPic = (e) => {
        e.preventDefault()
        var params = {
            type:2,
            pic:''
        }
        if(window.FileReader) {
            var file  = e.target.files[0],
                reader = new FileReader();
            //文件大小限制
            if(file.size>1024*1024*2){
                Message.warning('图片大小不能超过2MB哦！',2);
            	return false;
            }
            if (file && file.type.match('image.*')) {
                reader.readAsDataURL(file);
            }
        }
        reader.onload = () =>{
            //上传接口，上传base64图片二进制数据
            //前方案-截取base64后部分
            //base64,(.+)/.exec(reader.result)[1];
            //现方案
            params.pic = reader.result;
            this.uploadPoster(params)
            this.setState({
                uploadPicSucc: true,
                isUploadPoster: true
            })
        }
    }
    crop=(e)=>{
    	//做属性修正
        //兼容性处理
        e = window.event||e;
        var target=e.srcElement ? e.srcElement:e.target;
        var x=parseInt(e.detail.x),
            y=parseInt(e.detail.y),
            w=parseInt(e.detail.width),
            h=parseInt(e.detail.height);
        //属性修正
        if(x<0)x=0;
        if(y<0)y=0;
        if(target.width<x+w){w=target.width-x};
        if(target.height<y+h){h=target.height-y};
        //处理完毕
        this.setState({
            cropInfo:{
                x:x,
                y:y,
                w:w,
                h:h
            }
        })
    }
    uploadPoster=(params)=>{
            request
                .post(`${host}author/uploadpic`)
                .withCredentials()
                .set('Content-Type','application/x-www-form-urlencoded')
                .send(params)
                .end((err, res)=>{
                    if(res.body.code == 0){
                        //直接拿本地上传的文件base64显示，减少来回再请求接口
                        var text = JSON.parse(res.text),
                            posterData = text.data.url,
                            imgView = params.pic;
                        this.setState({
                            imgView: imgView,
                            posterData: posterData
                        })
                    }else {

                    }
                })
    }
    savePoster=(proxy,e)=> {
        //是否剪切
        var _this = this,
            uploadJSON=Object.assign({
                url: _this.state.imgView
            },
            this.state.cropInfo
        )
        request
            .post(`${host}author/cropImage`)
            .set('Content-Type','application/x-www-form-urlencoded')
            .withCredentials()
            .send(uploadJSON)
            .end((err,res)=>{
                if (res.body.code == 0) {
                	//如果为空，就使用原图
                	if(!res.body.data.url){
                		res.body.data.url=this.state.posterData
                	}
                    this.setState({
                        savedPoster: res.body.data.url
                    })
                    if(this.props.onChange&&typeof this.props.onChange=='function'){
                        this.props.onChange(res.body.data.url);
                        this.setState({uploadPicSucc:false})
                    }
                }else {
                    Message.error(res.body.desc,2)
                }                
                
            })
    }
    render(){
        const {open,onClickSide,onChange,handleExtract} = this.props
        return(
            <div className="xk_UploaderWithEdit" style={open?{display:'block'}:{display:'none'}}>
                <div className="xk_UploaderWithEdit-container">
                    
                    <div className="xk_UploaderWithEdit-container-nav">
                        <a 
                            className="tabChange" 
                            onClick={()=>this.setState({isUploadPoster:true})}>上传封面
                        </a>
                        <i 
                            onClick={()=>{
                                onChange();
                                this.setState({uploadPicSucc:false})
                            }}>
                        </i>
                    </div>
                    {this.state.isUploadPoster?
                        <div className="xk_UploaderWithEdit-container-loadPic">             	
                            {!this.state.uploadPicSucc?
                                <div className="poster-upload">
                                	<label className="posterActionArea" htmlFor="posterInput">
                                        <i></i>
                                		<div className="loadPic-logo"></div>
                                		<div href="javascript:void(0);" className="upload-pointer"></div>
                                		<input id="posterInput"
                                    		type="file" ref="fileInput" accept="image/jpg,image/jpeg,image/png"
                                    		className="xk_UploaderWithEdit-container-input"
                                    		onChange={this.handleUploadPic}
                                		/>
                                	</label>
                                    <div className="poster-extract">
                                        <a href="javascript:void(0);" onClick={handleExtract}>抽取封面</a>
                                    </div>                                    
                                    <span className="tips">图片不超过5MB</span>
                                    <p>提示：上传优质视频，将有利于获得更多的推荐机会，请务必上传和视频内容相关，有引导价值的图片，如有作弊情况将被封号处理。</p>
                                </div>:
                                <div className="poster-address">
                                    <div className="poster-address-container">
                                        {/*<div className="poster-address-banner">
                                            <a className="turn"><i className="address-left"></i>左转</a>
                                            <a className="turn"><i className="address-right"></i>右转</a>
                                        </div>*/}
                                        <div className="poster-address-img">
                                        	<Cropper
											    ref='cropper'
											    src={this.state.imgView}
											    style={{height: 240, width:480}}
											    aspectRatio={16 / 9}
											    guides={false}
											    viewMode={1}
											    crop={this.crop}
											    preview='.previewContainer' 
                                            /> 
                                        </div>
                                        <div className="poster-address-preview" >
                                            <div>剪裁预览</div>
                                            <div className="previewContainer"></div>
                                        </div>
                                    </div>
                                    <div className="poster-address-footer">
                                        <a>
                                            <input
                                                type="file" 
                                                accept="image/jpg,image/jpeg,image/png"
                                                className="poster-address-retry"
                                                onChange={this.handleUploadPic}
                                            />
                                        </a>
                                        <a onClick={this.savePoster}>保存</a>
                                    </div>
                                </div>
                            }
                        </div>:
                        <div className="xk_UploaderWithEdit-container-OSPic">
                            <div className="OSPic-to-loadPic">
                                <div className="OSPic-to-loadPic-text">
                                    视频处理中，暂无系统封面，请使用上传封面
                                </div>
                                <div className="OSPic-to-loadPic-btn">
                                    <a>
                                        <input
                                            type="file" accept="image/jpg,image/jpeg,image/png"
                                            className="OSPic-to-loadPic-file"
                                            onChange={this.handleUploadPic}
                                        />
                                    </a>
                                </div>
                                <div className="OSPic-to-loadPic-desc">
                                    上传优质的视频封面将获取更多的播放量
                                </div>
                            </div>
                        </div>
                    }
                </div>
                <div className="xk_UploaderWithEdit-layout" onClick={onClickSide}></div>
            </div>
        )
    }
}

export default UploaderWithEdit